﻿/**
* Clean Library on Linkages by Grant Skinner. Aug 10, 2004
* Visit www.gskinner.com for documentation, updates and more free code.
*
* Notice: All JSFL commands have the ability to damage your files. It is recommended
* that you run these commands on copies of your files. You take all responsibility
* for any problems or damage incurred directly or indirectly from running this command.
*
* You may distribute this code freely, as long as this comment block remains intact.
*/

var lib = fl.getDocumentDOM().library;
var libItems = lib.items;
var l = libItems.length;
for (var i = 0;i<l;i++) {
	var libItem = libItems[i];
	if (libItem.linkageIdentifier == undefined) { continue; }
	if (libItem.linkageIdentifier.indexOf(".") == -1) { continue; }
	var path = libItem.linkageIdentifier.split(".");
	
	if (path[path.length-1].indexOf(":") != -1) {
		// we're going to need an assets dir too:
		var foo = path[path.length-1].split(":")[0]+" assets:";
		path.splice(path.length-1,0,foo);
	}
	
	var dirSuccess = true;
	// walk the path, and create directories if they don't already exist:
	var l2 = path.length;
	var strPath="";
	for (var j=0;j<l2-1;j++) {
		strPath += (j==0) ? path[j] : "/"+path[j];
		if (!lib.itemExists(strPath)) {
			// doesn't exist, create dir:
			lib.addNewItem("folder",strPath);
		}
		var dirIndex = lib.findItemIndex(strPath);
		var dir = lib.items[dirIndex];
		if (dir.itemType != "folder") {
			fl.trace(">> ERROR: directory could not be created: "+strPath);
			dirSuccess = false;
			break;
		}
	}
	if (!dirSuccess) {
		fl.trace(">> ERROR: library item could not be moved because the target folder does not exist: "+libItem.name);
		continue;
	}
	// now move the original item into the new directory:
	var moveSuccess = lib.moveToFolder(strPath,libItem.name,false);
	if (moveSuccess) {
		fl.trace("Item moved successfully: "+libItem.name);
	} else {
		fl.trace(">> ERROR: library item could not be moved, an existing item with the same name may already exist in the folder ("+strPath+"): "+libItem.name);
	}
}
